<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

<meta name="generator" content="PHPDoctor 2RC4 (http://peej.github.com/phpdoctor/)">
<meta name="when" content="Fri, 15 Apr 2011 16:43:07 +0000">

<link rel="stylesheet" type="text/css" href="../../../stylesheet.css">
<link rel="start" href="../../../overview-summary.html">

<title>doclets/standard/packageFrameWriter.php (PHPDoctor)</title>

</head>
<body id="file" onload="parent.document.title=document.title;">

<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../../overview-files.html">Files</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../todo-list.html">Todo</a></li>
<li><a href="../../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../../index.html" target="_top">Frames</a>
<a href="../../../source/doclets/standard/packageframewriter.php.html" target="_top">No frames</a>
</div>
<hr>

<h1>doclets/standard/packageFrameWriter.php</h1>
<hr>

<a name="line1"></a><pre><?php
<a name="line2"></a>/*
<a name="line3"></a>PHPDoctor: The PHP Documentation Creator
<a name="line4"></a>Copyright (C) 2004 Paul James <paul@peej.co.uk>
<a name="line5"></a>
<a name="line6"></a>This program is free software; you can redistribute it and/or modify
<a name="line7"></a>it under the terms of the GNU General Public License as published by
<a name="line8"></a>the Free Software Foundation; either version 2 of the License, or
<a name="line9"></a>(at your option) any later version.
<a name="line10"></a>
<a name="line11"></a>This program is distributed in the hope that it will be useful,
<a name="line12"></a>but WITHOUT ANY WARRANTY; without even the implied warranty of
<a name="line13"></a>MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
<a name="line14"></a>GNU General Public License for more details.
<a name="line15"></a>
<a name="line16"></a>You should have received a copy of the GNU General Public License
<a name="line17"></a>along with this program; if not, write to the Free Software
<a name="line18"></a>Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<a name="line19"></a>*/
<a name="line20"></a>
<a name="line21"></a>/** This generates the package-frame.html file that lists the interfaces and
<a name="line22"></a> * classes in a given package for displaying in the lower-left frame of the
<a name="line23"></a> * frame-formatted default output.
<a name="line24"></a> *
<a name="line25"></a> * @package PHPDoctor\Doclets\Standard
<a name="line26"></a> */
<a name="line27"></a>class PackageFrameWriter extends HTMLWriter
<a name="line28"></a>{
<a name="line29"></a>
<a name="line30"></a>	/** Build the package frame index.
<a name="line31"></a>	 *
<a name="line32"></a>	 * @param Doclet doclet
<a name="line33"></a>	 */
<a name="line34"></a>	function packageFrameWriter(&$doclet)
<a name="line35"></a>    {
<a name="line36"></a>	
<a name="line37"></a>		parent::HTMLWriter($doclet);
<a name="line38"></a>		
<a name="line39"></a>		$rootDoc =& $this->_doclet->rootDoc();
<a name="line40"></a>		
<a name="line41"></a>		$this->_output =& $this->_allItems($rootDoc);
<a name="line42"></a>		$this->_write('allitems-frame.html', 'All Items', FALSE);
<a name="line43"></a>
<a name="line44"></a>        $packages =& $rootDoc->packages();
<a name="line45"></a>        ksort($packages);
<a name="line46"></a>        
<a name="line47"></a>		foreach($packages as $packageName => $package) {
<a name="line48"></a>		
<a name="line49"></a>			$this->_depth = $package->depth() + 1;
<a name="line50"></a>			
<a name="line51"></a>			$this->_output =& $this->_buildFrame($package);
<a name="line52"></a>			$this->_write($package->asPath().'/package-frame.html', $package->name(), FALSE);
<a name="line53"></a>			
<a name="line54"></a>		}
<a name="line55"></a>	
<a name="line56"></a>	}
<a name="line57"></a>	
<a name="line58"></a>	/** Build package frame
<a name="line59"></a>	 *
<a name="line60"></a>	 * @return str
<a name="line61"></a>	 */
<a name="line62"></a>	function &_buildFrame(&$package)
<a name="line63"></a>    {
<a name="line64"></a>		ob_start();
<a name="line65"></a>
<a name="line66"></a>		echo '<body id="frame">', "\n\n";
<a name="line67"></a>
<a name="line68"></a>		echo '<h1><a href="package-summary.html" target="main">', $package->name(), "</a></h1>\n\n";
<a name="line69"></a>
<a name="line70"></a>		$classes =& $package->ordinaryClasses();
<a name="line71"></a>		if ($classes && is_array($classes)) {
<a name="line72"></a>            ksort($classes);
<a name="line73"></a>			echo "<h2>Classes</h2>\n";
<a name="line74"></a>			echo "<ul>\n";
<a name="line75"></a>			foreach($classes as $name => $class) {
<a name="line76"></a>				echo '<li><a href="', str_repeat('../', $package->depth() + 1), $classes[$name]->asPath(), '" target="main">', $classes[$name]->name(), "</a></li>\n";
<a name="line77"></a>			}
<a name="line78"></a>			echo "</ul>\n\n";
<a name="line79"></a>		}
<a name="line80"></a>
<a name="line81"></a>		$interfaces =& $package->interfaces();
<a name="line82"></a>		if ($interfaces && is_array($interfaces)) {
<a name="line83"></a>            ksort($interfaces);
<a name="line84"></a>			echo "<h2>Interfaces</h2>\n";
<a name="line85"></a>			echo "<ul>\n";
<a name="line86"></a>			foreach($interfaces as $name => $interface) {
<a name="line87"></a>				echo '<li><a href="', str_repeat('../', $package->depth() + 1), $interfaces[$name]->asPath(), '" target="main">', $interfaces[$name]->name(), "</a></li>\n";
<a name="line88"></a>			}
<a name="line89"></a>			echo "</ul>\n\n";
<a name="line90"></a>		}
<a name="line91"></a>
<a name="line92"></a>		$exceptions =& $package->exceptions();
<a name="line93"></a>		if ($exceptions && is_array($exceptions)) {
<a name="line94"></a>            ksort($exceptions);
<a name="line95"></a>			echo "<h2>Exceptions</h2>\n";
<a name="line96"></a>			echo "<ul>\n";
<a name="line97"></a>			foreach($exceptions as $name => $exception) {
<a name="line98"></a>				echo '<li><a href="', str_repeat('../', $package->depth() + 1), $exceptions[$name]->asPath(), '" target="main">', $exceptions[$name]->name(), "</a></li>\n";
<a name="line99"></a>			}
<a name="line100"></a>			echo "</ul>\n\n";
<a name="line101"></a>		}
<a name="line102"></a>
<a name="line103"></a>		$functions =& $package->functions();
<a name="line104"></a>		if ($functions && is_array($functions)) {
<a name="line105"></a>            ksort($functions);
<a name="line106"></a>			echo "<h2>Functions</h2>\n";
<a name="line107"></a>			echo "<ul>\n";
<a name="line108"></a>			foreach($functions as $name => $function) {
<a name="line109"></a>				echo '<li><a href="', str_repeat('../', $package->depth() + 1), $functions[$name]->asPath(), '" target="main">', $functions[$name]->name(), "</a></li>\n";
<a name="line110"></a>			}
<a name="line111"></a>			echo "</ul>\n\n";
<a name="line112"></a>		}
<a name="line113"></a>
<a name="line114"></a>		$globals =& $package->globals();
<a name="line115"></a>		if ($globals && is_array($globals)) {
<a name="line116"></a>            ksort($globals);
<a name="line117"></a>			echo "<h2>Globals</h2>\n";
<a name="line118"></a>			echo "<ul>\n";
<a name="line119"></a>			foreach($globals as $name => $global) {
<a name="line120"></a>				echo '<li><a href="', str_repeat('../', $package->depth() + 1), $globals[$name]->asPath(), '" target="main">', $globals[$name]->name(), "</a></li>\n";
<a name="line121"></a>			}
<a name="line122"></a>			echo "</ul>\n\n";
<a name="line123"></a>		}
<a name="line124"></a>
<a name="line125"></a>		echo '</body>', "\n\n";
<a name="line126"></a>
<a name="line127"></a>		$output = ob_get_contents();
<a name="line128"></a>		ob_end_clean();
<a name="line129"></a>		
<a name="line130"></a>		return $output;
<a name="line131"></a>	}
<a name="line132"></a>
<a name="line133"></a>	/** Build all items frame
<a name="line134"></a>	 *
<a name="line135"></a>	 * @return str
<a name="line136"></a>	 */
<a name="line137"></a>	function &_allItems(&$rootDoc)
<a name="line138"></a>    {
<a name="line139"></a>		ob_start();
<a name="line140"></a>
<a name="line141"></a>		echo '<body id="frame">', "\n\n";
<a name="line142"></a>
<a name="line143"></a>		echo "<h1>All Items</h1>\n\n";
<a name="line144"></a>
<a name="line145"></a>		$classes =& $rootDoc->classes();
<a name="line146"></a>		if ($classes) {
<a name="line147"></a>            ksort($classes);
<a name="line148"></a>			echo "<h2>Classes</h2>\n";
<a name="line149"></a>			echo "<ul>\n";
<a name="line150"></a>			foreach($classes as $name => $class) {
<a name="line151"></a>				$package =& $classes[$name]->containingPackage();
<a name="line152"></a>				if ($class->isInterface()) {
<a name="line153"></a>					echo '<li><em><a href="', $classes[$name]->asPath(), '" title="', $classes[$name]->packageName(),'" target="main">', $classes[$name]->name(), "</a></em></li>\n";
<a name="line154"></a>				} else {
<a name="line155"></a>					echo '<li><a href="', $classes[$name]->asPath(), '" title="', $classes[$name]->packageName(),'" target="main">', $classes[$name]->name(), "</a></li>\n";
<a name="line156"></a>				}
<a name="line157"></a>			}
<a name="line158"></a>			echo "</ul>\n\n";
<a name="line159"></a>		}
<a name="line160"></a>
<a name="line161"></a>		$functions =& $rootDoc->functions();
<a name="line162"></a>		if ($functions) {
<a name="line163"></a>            ksort($functions);
<a name="line164"></a>			echo "<h2>Functions</h2>\n";
<a name="line165"></a>			echo "<ul>\n";
<a name="line166"></a>			foreach($functions as $name => $function) {
<a name="line167"></a>				$package =& $functions[$name]->containingPackage();
<a name="line168"></a>				echo '<li><a href="', $package->asPath(), '/package-functions.html#', $functions[$name]->name(), '()" title="', $functions[$name]->packageName(),'" target="main">', $functions[$name]->name(), "</a></li>\n";
<a name="line169"></a>			}
<a name="line170"></a>			echo "</ul>\n\n";
<a name="line171"></a>		}
<a name="line172"></a>
<a name="line173"></a>		$globals =& $rootDoc->globals();
<a name="line174"></a>		if ($globals) {
<a name="line175"></a>            ksort($globals);
<a name="line176"></a>			echo "<h2>Globals</h2>\n";
<a name="line177"></a>			echo "<ul>\n";
<a name="line178"></a>			foreach($globals as $name => $global) {
<a name="line179"></a>				$package =& $globals[$name]->containingPackage();
<a name="line180"></a>				echo '<li><a href="', $package->asPath(), '/package-globals.html#', $globals[$name]->name(), '" title="', $globals[$name]->packageName(),'" target="main">', $globals[$name]->name(), "</a></li>\n";
<a name="line181"></a>			}
<a name="line182"></a>			echo "</ul>\n\n";
<a name="line183"></a>		}
<a name="line184"></a>		
<a name="line185"></a>		echo '</body>', "\n\n";
<a name="line186"></a>
<a name="line187"></a>		$output = ob_get_contents();
<a name="line188"></a>		ob_end_clean();
<a name="line189"></a>		
<a name="line190"></a>		return $output;
<a name="line191"></a>	}
<a name="line192"></a>
<a name="line193"></a>}
<a name="line194"></a>
<a name="line195"></a>?>
<a name="line196"></a>
<a name="line197"></a></pre>
<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../../overview-files.html">Files</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../todo-list.html">Todo</a></li>
<li><a href="../../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../../index.html" target="_top">Frames</a>
<a href="../../../source/doclets/standard/packageframewriter.php.html" target="_top">No frames</a>
</div>
<hr>

<p id="footer">This document was generated by <a href="http://peej.github.com/phpdoctor/">PHPDoctor: The PHP Documentation Creator</a></p>

</body>

</html>